Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DOM/dom_oce.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DOM/dom_oce.F90	(revision 14199)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DOM/dom_oce.F90	(revision 14200)
@@ -136,7 +136,18 @@
    !
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   ff_f  , ff_t                    !: Coriolis factor at f- & t-points  [1/s]
+   
    !!----------------------------------------------------------------------
    !! vertical coordinate and scale factors
    !! ---------------------------------------------------------------------
+#if defined key_qco
+   LOGICAL, PUBLIC, PARAMETER ::   lk_qco    = .TRUE.   !: qco key flag
+#else
+   LOGICAL, PUBLIC, PARAMETER ::   lk_qco    = .FALSE.  !: qco key flag
+#endif
+#if defined key_linssh
+   LOGICAL, PUBLIC, PARAMETER ::   lk_linssh = .TRUE.   !: linssh key flag
+#else
+   LOGICAL, PUBLIC, PARAMETER ::   lk_linssh = .FALSE.  !: linssh key flag
+#endif
    LOGICAL, PUBLIC ::   ln_zco       !: z-coordinate - full step
    LOGICAL, PUBLIC ::   ln_zps       !: z-coordinate - partial step
@@ -151,10 +162,10 @@
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::    e3uw_0   !: uw-vert. scale factor [m]
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::    e3vw_0   !: vw-vert. scale factor [m]
-   !                                                        !  time-dependent scale factors
-#if ! defined key_qco
+
+   !                                                        !  time-dependent scale factors     (domvvl)
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:,:) ::   e3t, e3u, e3v, e3w, e3uw, e3vw  !: vert. scale factor [m]
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)   ::   e3f                             !: F-point vert. scale factor [m]
-#endif
-   !                                                        !  time-dependent ratio ssh / h_0
+
+   !                                                        !  time-dependent ratio ssh / h_0   (domqco)
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)   ::   r3t, r3u, r3v                   !: time-dependent    ratio at t-, u- and v-point [-]
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)     ::   r3f                             !: mid-time-level    ratio at f-point            [-]
@@ -165,5 +176,6 @@
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)   ::   gdepw_0  !: w- depth              [m]
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)   ::   gde3w_0  !: w- depth (sum of e3w) [m]
-   !                                                        !  time-dependent depths of cells
+   
+   !                                                        !  time-dependent depths of cells   (domvvl)
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:,:) ::  gdept, gdepw
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)   ::  gde3w
@@ -174,8 +186,7 @@
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)     ::   hv_0, r1_hv_0   !: v-depth        [m] and [1/m]
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)     ::   hf_0, r1_hf_0   !: f-depth        [m] and [1/m]
-   !                                                        ! time-dependent heights of ocean water column
-#if ! defined key_qco
+   
+   !                                                        ! time-dependent heights of ocean water column   (domvvl)
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)     ::   ht          !: t-points           [m]
-#endif
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)   ::   hu, r1_hu   !: u-depth            [m] and [1/m]
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)   ::   hv, r1_hv   !: v-depth            [m] and [1/m]
@@ -207,7 +218,6 @@
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:), TARGET ::   tmask, umask, vmask, wmask, fmask   !: land/ocean mask at T-, U-, V-, W- and F-pts
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:), TARGET ::   wumask, wvmask                      !: land/ocean mask at WU- and WV-pts
-#if defined key_qco
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:), TARGET ::   fe3mask                             !: land/ocean mask at F-pts for qco
-#endif
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:), TARGET ::   fe3mask                             !: land/ocean mask at F-pts (qco only)
+
    !!----------------------------------------------------------------------
    !! calendar variables
@@ -301,29 +311,39 @@
          !
       ii = ii+1
-      ALLOCATE( gdept_0(jpi,jpj,jpk)     , gdepw_0(jpi,jpj,jpk)     , gde3w_0(jpi,jpj,jpk) ,      &
-         &      gdept  (jpi,jpj,jpk,jpt) , gdepw  (jpi,jpj,jpk,jpt) , gde3w  (jpi,jpj,jpk) , STAT=ierr(ii) )
-         !
-      ii = ii+1
-      ALLOCATE(  e3t_0(jpi,jpj,jpk) , e3u_0 (jpi,jpj,jpk) , e3v_0 (jpi,jpj,jpk) , e3f_0(jpi,jpj,jpk) ,      &
-         &       e3w_0(jpi,jpj,jpk) , e3uw_0(jpi,jpj,jpk) , e3vw_0(jpi,jpj,jpk)                      ,  STAT=ierr(ii) )
+      ALLOCATE( gdept_0 (jpi,jpj,jpk) , gdepw_0 (jpi,jpj,jpk) , gde3w_0(jpi,jpj,jpk) ,     &
+         &      gdept_1d(        jpk) , gdepw_1d(        jpk)                        , STAT=ierr(ii) )
+         !
+      ii = ii+1
+      ALLOCATE(  e3t_0 (jpi,jpj,jpk) , e3u_0 (jpi,jpj,jpk) , e3v_0 (jpi,jpj,jpk) , e3f_0(jpi,jpj,jpk) ,     &
+         &       e3w_0 (jpi,jpj,jpk) , e3uw_0(jpi,jpj,jpk) , e3vw_0(jpi,jpj,jpk)                      ,     &
+         &       e3t_1d(        jpk) , e3w_1d(        jpk)                                            , STAT=ierr(ii) )
+         !
+      ii = ii+1
+      ALLOCATE( ht_0(jpi,jpj) ,    hu_0(jpi,jpj)    ,    hv_0(jpi,jpj)     , hf_0(jpi,jpj) ,       &
+         &   r1_ht_0(jpi,jpj) , r1_hu_0(jpi,jpj) ,    r1_hv_0(jpi,jpj),   r1_hf_0(jpi,jpj) ,   STAT=ierr(ii)  )
          !
 #if defined key_qco
-      ii = ii+1
-      ALLOCATE( r3t  (jpi,jpj,jpt)   , r3u  (jpi,jpj,jpt)    , r3v  (jpi,jpj,jpt)    , r3f  (jpi,jpj) ,      &
-         &      r3t_f(jpi,jpj)       , r3u_f(jpi,jpj)        , r3v_f(jpi,jpj)                         ,  STAT=ierr(ii) )
+         ! qco : ssh to h ratio and specific fmask
+      ii = ii+1
+      ALLOCATE( r3t  (jpi,jpj,jpt) , r3u  (jpi,jpj,jpt) , r3v  (jpi,jpj,jpt) , r3f  (jpi,jpj) ,      &
+         &      r3t_f(jpi,jpj)     , r3u_f(jpi,jpj)     , r3v_f(jpi,jpj)                      ,  STAT=ierr(ii) )
+         !
+      ii = ii+1
+      ALLOCATE( fe3mask(jpi,jpj,jpk) , STAT=ierr(ii) )
+         !
+#elif defined key_linssh
+         ! linear ssh no time varying coordinate arrays
 #else
+         ! vvl : time varation for all vertical coordinate variables
+      ii = ii+1
+      ALLOCATE( gdept  (jpi,jpj,jpk,jpt) , gdepw  (jpi,jpj,jpk,jpt) , gde3w  (jpi,jpj,jpk) , STAT=ierr(ii) )
+         !
       ii = ii+1
       ALLOCATE( e3t(jpi,jpj,jpk,jpt) , e3u (jpi,jpj,jpk,jpt) , e3v (jpi,jpj,jpk,jpt) , e3f(jpi,jpj,jpk) ,      &
          &      e3w(jpi,jpj,jpk,jpt) , e3uw(jpi,jpj,jpk,jpt) , e3vw(jpi,jpj,jpk,jpt)                    ,  STAT=ierr(ii) )
-#endif
-         !
-      ii = ii+1
-      ALLOCATE( ht_0(jpi,jpj) ,    hu_0(jpi,jpj)    ,    hv_0(jpi,jpj)     , hf_0(jpi,jpj) ,       &
-         &   r1_ht_0(jpi,jpj) , r1_hu_0(jpi,jpj) ,    r1_hv_0(jpi,jpj),   r1_hf_0(jpi,jpj) ,   STAT=ierr(ii)  )
-         !
-#if ! defined key_qco
-      ii = ii+1
-      ALLOCATE( ht  (jpi,jpj) ,    hu  (jpi,jpj,jpt),    hv  (jpi,jpj,jpt)                 ,       &
-         &                      r1_hu  (jpi,jpj,jpt), r1_hv  (jpi,jpj,jpt)                 ,   STAT=ierr(ii)  )
+         !
+      ii = ii+1
+      ALLOCATE( ht  (jpi,jpj) ,    hu  (jpi,jpj,jpt),    hv  (jpi,jpj,jpt) ,       &
+         &                      r1_hu  (jpi,jpj,jpt), r1_hv  (jpi,jpj,jpt) ,   STAT=ierr(ii)  )
 #endif
          !
@@ -332,10 +352,7 @@
          !
       ii = ii+1
-      ALLOCATE( gdept_1d(jpk) , gdepw_1d(jpk) , e3t_1d(jpk) , e3w_1d(jpk) , STAT=ierr(ii) )
-         !
-      ii = ii+1
-      ALLOCATE( tmask_i(jpi,jpj) , tmask_h(jpi,jpj) ,                        &
+      ALLOCATE( tmask_i(jpi,jpj) , tmask_h(jpi,jpj) ,                                           &
          &      ssmask (jpi,jpj) , ssumask(jpi,jpj) , ssvmask(jpi,jpj) , ssfmask(jpi,jpj) ,     &
-         &      mbkt   (jpi,jpj) , mbku   (jpi,jpj) , mbkv   (jpi,jpj) ,                    STAT=ierr(ii) )
+         &      mbkt   (jpi,jpj) , mbku   (jpi,jpj) , mbkv   (jpi,jpj)                    , STAT=ierr(ii) )
          !
       ii = ii+1
@@ -348,9 +365,4 @@
       ii = ii+1
       ALLOCATE( wmask(jpi,jpj,jpk) , wumask(jpi,jpj,jpk), wvmask(jpi,jpj,jpk) , STAT=ierr(ii) )
-#if defined key_qco
-         !
-      ii = ii+1
-      ALLOCATE( fe3mask(jpi,jpj,jpk) , STAT=ierr(ii) )
-#endif
       !
       dom_oce_alloc = MAXVAL(ierr)
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DOM/domain.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DOM/domain.F90	(revision 14199)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DOM/domain.F90	(revision 14200)
@@ -28,10 +28,15 @@
    USE oce            ! ocean variables
    USE dom_oce        ! domain: ocean
+   USE domtile        ! tiling utilities
 #if defined key_qco
-   USE domqco         ! quasi-eulerian
+   USE domqco         ! quasi-eulerian coord.
+#elif defined key_linssh
+   !                  ! fix in time coord.
 #else
-   USE domvvl         ! variable volume
-#endif
-   USE sshwzv  , ONLY : ssh_init_rst   ! set initial ssh
+   USE domvvl         ! variable volume coord.
+#endif
+#if defined key_agrif
+   USE agrif_oce_interp, ONLY : Agrif_istate_ssh ! ssh interpolated from parent
+#endif
    USE sbc_oce        ! surface boundary condition: ocean
    USE trc_oce        ! shared ocean & passive tracers variab
@@ -39,5 +44,4 @@
    USE domhgr         ! domain: set the horizontal mesh
    USE domzgr         ! domain: set the vertical mesh
-   USE domtile
    USE dommsk         ! domain: set the mask system
    USE domwri         ! domain: write the meshmask file
@@ -51,5 +55,5 @@
    USE lbclnk         ! ocean lateral boundary condition (or mpp link)
    USE lib_mpp        ! distributed memory computing library
-   USE restart        ! only for lrst_oce
+   USE restart        ! only for lrst_oce and rst_read_ssh
 
    IMPLICIT NONE
@@ -169,5 +173,5 @@
          DO_2D( 1, 1, 1, 1 )
             IF( ht_0(ji,jj) < 0._wp .AND. ssmask(ji,jj) == 1._wp ) THEN
-               CALL ctl_stop( 'ssh_init_rst : ht_0 must be positive at potentially wet points' )
+               CALL ctl_stop( 'dom_init : ht_0 must be positive at potentially wet points' )
             ENDIF
          END_2D
@@ -177,14 +181,22 @@
       !
       !                                 != ssh initialization
-      IF( .NOT.l_offline .AND. .NOT.l_SAS ) THEN
-         CALL ssh_init_rst( Kbb, Kmm, Kaa )
-      ELSE
+      !
+      IF( l_offline .OR. l_SAS ) THEN        !* No ocean dynamics calculation : set to 0
          ssh(:,:,:) = 0._wp
-      ENDIF
-      !
+#if defined key_agrif
+      ELSEIF( .NOT.Agrif_root() .AND.    &
+         &     ln_init_chfrpar ) THEN        !* Interpolate initial ssh from parent
+         CALL Agrif_istate_ssh( Kbb, Kmm, Kaa )
+#endif
+      ELSE                                   !* Read in restart file or set by user
+         CALL rst_read_ssh( Kbb, Kmm, Kaa )
+      ENDIF
+      !     
 #if defined key_qco
       !                                 != Quasi-Euerian coordinate case
       !
       IF( .NOT.l_offline )   CALL dom_qco_init( Kbb, Kmm, Kaa )
+#elif defined key_linssh
+      !                                 != Fix in time : key_linssh case, set through domzgr_substitute.h90
 #else
       !
@@ -345,4 +357,8 @@
       IF(lwm) WRITE( numond, namdom )
       !
+#if defined key_linssh
+      ln_linssh = lk_linssh      ! overwrite ln_linssh with the logical associated with key_linssh
+#endif
+      !
 #if defined key_agrif
       IF( .NOT. Agrif_Root() ) THEN    ! AGRIF child, subdivide the Parent timestep
@@ -371,5 +387,5 @@
       !
 #if defined key_qco
-      IF( ln_linssh )   CALL ctl_stop( 'STOP','domain: key_qco and ln_linssh = T are incompatible' )
+      IF( ln_linssh )   CALL ctl_stop( 'STOP','domain: key_qco and ln_linssh=T or key_linssh are incompatible' )
 #endif
       !
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DOM/domqco.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DOM/domqco.F90	(revision 14199)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DOM/domqco.F90	(revision 14200)
@@ -116,6 +116,11 @@
       !                    !== Set of all other vertical scale factors  ==!  (now and before)
       !                                ! Horizontal interpolation of e3t
+#if defined key_RK3
+      CALL dom_qco_r3c( ssh(:,:,Kbb), r3t(:,:,Kbb), r3u(:,:,Kbb), r3v(:,:,Kbb), r3f(:,:) )
+      CALL dom_qco_r3c( ssh(:,:,Kmm), r3t(:,:,Kmm), r3u(:,:,Kmm), r3v(:,:,Kmm)           )
+#else
       CALL dom_qco_r3c( ssh(:,:,Kbb), r3t(:,:,Kbb), r3u(:,:,Kbb), r3v(:,:,Kbb)           )
       CALL dom_qco_r3c( ssh(:,:,Kmm), r3t(:,:,Kmm), r3u(:,:,Kmm), r3v(:,:,Kmm), r3f(:,:) )
+#endif
       !
    END SUBROUTINE dom_qco_zgr
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DOM/domvvl.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DOM/domvvl.F90	(revision 14199)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DOM/domvvl.F90	(revision 14200)
@@ -2,5 +2,5 @@
    !!======================================================================
    !!                       ***  MODULE domvvl   ***
-   !! Ocean : 
+   !! Ocean :
    !!======================================================================
    !! History :  2.0  !  2006-06  (B. Levier, L. Marie)  original code
@@ -26,9 +26,4 @@
    USE timing          ! Timing
 
-#if defined key_agrif
-   USE agrif_oce       ! initial state interpolation
-   USE agrif_oce_interp 
-#endif
-
    IMPLICIT NONE
    PRIVATE
@@ -55,7 +50,9 @@
    REAL(wp)        , ALLOCATABLE, SAVE, DIMENSION(:,:)   :: frq_rst_hdv                 ! retoring period for low freq. divergence
 
-#if defined key_qco
+#if defined key_qco   ||   defined key_linssh
    !!----------------------------------------------------------------------
-   !!   'key_qco'      EMPTY MODULE      Quasi-Eulerian vertical coordonate
+   !!   'key_qco'                        Quasi-Eulerian vertical coordinate
+   !!       OR         EMPTY MODULE
+   !!   'key_linssh'                        Fix in time vertical coordinate
    !!----------------------------------------------------------------------
 #else
@@ -63,5 +60,5 @@
    !!   Default key      Old management of time varying vertical coordinate
    !!----------------------------------------------------------------------
-   
+
    !!----------------------------------------------------------------------
    !!   dom_vvl_init     : define initial vertical scale factors, depths and column thickness
@@ -78,5 +75,5 @@
    PUBLIC  dom_vvl_sf_update  ! called by step.F90
    PUBLIC  dom_vvl_interpol   ! called by dynnxt.F90
-   
+
    !! * Substitutions
 #  include "do_loop_substitute.h90"
@@ -114,5 +111,5 @@
       !!----------------------------------------------------------------------
       !!                ***  ROUTINE dom_vvl_init  ***
-      !!                   
+      !!
       !! ** Purpose :  Initialization of all scale factors, depths
       !!               and water column heights
@@ -123,8 +120,8 @@
       !! ** Action  : - e3t_(n/b) and tilde_e3t_(n/b)
       !!              - Regrid: e3[u/v](:,:,:,Kmm)
-      !!                        e3[u/v](:,:,:,Kmm)       
-      !!                        e3w(:,:,:,Kmm)           
+      !!                        e3[u/v](:,:,:,Kmm)
+      !!                        e3w(:,:,:,Kmm)
       !!                        e3[u/v]w_b
-      !!                        e3[u/v]w_n      
+      !!                        e3[u/v]w_n
       !!                        gdept(:,:,:,Kmm), gdepw(:,:,:,Kmm) and gde3w
       !!              - h(t/u/v)_0
@@ -156,6 +153,6 @@
       !!----------------------------------------------------------------------
       !!                ***  ROUTINE dom_vvl_init  ***
-      !!                   
-      !! ** Purpose :  Interpolation of all scale factors, 
+      !!
+      !! ** Purpose :  Interpolation of all scale factors,
       !!               depths and water column heights
       !!
@@ -164,8 +161,8 @@
       !! ** Action  : - e3t_(n/b) and tilde_e3t_(n/b)
       !!              - Regrid: e3(u/v)_n
-      !!                        e3(u/v)_b       
-      !!                        e3w_n           
-      !!                        e3(u/v)w_b      
-      !!                        e3(u/v)w_n      
+      !!                        e3(u/v)_b
+      !!                        e3w_n
+      !!                        e3(u/v)w_b
+      !!                        e3(u/v)w_n
       !!                        gdept_n, gdepw_n and gde3w_n
       !!              - h(t/u/v)_0
@@ -185,8 +182,8 @@
       CALL dom_vvl_interpol( e3t(:,:,:,Kbb), e3u(:,:,:,Kbb), 'U' )    ! from T to U
       CALL dom_vvl_interpol( e3t(:,:,:,Kmm), e3u(:,:,:,Kmm), 'U' )
-      CALL dom_vvl_interpol( e3t(:,:,:,Kbb), e3v(:,:,:,Kbb), 'V' )    ! from T to V 
+      CALL dom_vvl_interpol( e3t(:,:,:,Kbb), e3v(:,:,:,Kbb), 'V' )    ! from T to V
       CALL dom_vvl_interpol( e3t(:,:,:,Kmm), e3v(:,:,:,Kmm), 'V' )
       CALL dom_vvl_interpol( e3u(:,:,:,Kmm), e3f(:,:,:), 'F' )    ! from U to F
-      !                                ! Vertical interpolation of e3t,u,v 
+      !                                ! Vertical interpolation of e3t,u,v
       CALL dom_vvl_interpol( e3t(:,:,:,Kmm), e3w (:,:,:,Kmm), 'W'  )  ! from T to W
       CALL dom_vvl_interpol( e3t(:,:,:,Kbb), e3w (:,:,:,Kbb), 'W'  )
@@ -210,14 +207,14 @@
          !    zcoef = tmask - wmask    ! 0 everywhere tmask = wmask, ie everywhere expect at jk = mikt
          !                             ! 1 everywhere from mbkt to mikt + 1 or 1 (if no isf)
-         !                             ! 0.5 where jk = mikt     
+         !                             ! 0.5 where jk = mikt
 !!gm ???????   BUG ?  gdept(:,:,:,Kmm) as well as gde3w  does not include the thickness of ISF ??
          zcoef = ( tmask(ji,jj,jk) - wmask(ji,jj,jk) )
          gdepw(ji,jj,jk,Kmm) = gdepw(ji,jj,jk-1,Kmm) + e3t(ji,jj,jk-1,Kmm)
          gdept(ji,jj,jk,Kmm) =      zcoef  * ( gdepw(ji,jj,jk  ,Kmm) + 0.5 * e3w(ji,jj,jk,Kmm))  &
-            &                + (1-zcoef) * ( gdept(ji,jj,jk-1,Kmm) +       e3w(ji,jj,jk,Kmm)) 
+            &                + (1-zcoef) * ( gdept(ji,jj,jk-1,Kmm) +       e3w(ji,jj,jk,Kmm))
          gde3w(ji,jj,jk) = gdept(ji,jj,jk,Kmm) - ssh(ji,jj,Kmm)
          gdepw(ji,jj,jk,Kbb) = gdepw(ji,jj,jk-1,Kbb) + e3t(ji,jj,jk-1,Kbb)
          gdept(ji,jj,jk,Kbb) =      zcoef  * ( gdepw(ji,jj,jk  ,Kbb) + 0.5 * e3w(ji,jj,jk,Kbb))  &
-            &                + (1-zcoef) * ( gdept(ji,jj,jk-1,Kbb) +       e3w(ji,jj,jk,Kbb)) 
+            &                + (1-zcoef) * ( gdept(ji,jj,jk-1,Kbb) +       e3w(ji,jj,jk,Kbb))
       END_3D
       !
@@ -278,5 +275,5 @@
             IF( cn_cfg == "orca" .OR. cn_cfg == "ORCA" ) THEN
                IF( nn_cfg == 3 ) THEN   ! ORCA2: Suppress ztilde in the Foxe Basin for ORCA2
-                  ii0 = 103 + nn_hls - 1   ;   ii1 = 111 + nn_hls - 1      
+                  ii0 = 103 + nn_hls - 1   ;   ii1 = 111 + nn_hls - 1
                   ij0 = 128 + nn_hls       ;   ij1 = 135 + nn_hls
                   frq_rst_e3t( mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) ) =  0.0_wp
@@ -290,13 +287,13 @@
 
 
-   SUBROUTINE dom_vvl_sf_nxt( kt, Kbb, Kmm, Kaa, kcall ) 
+   SUBROUTINE dom_vvl_sf_nxt( kt, Kbb, Kmm, Kaa, kcall )
       !!----------------------------------------------------------------------
       !!                ***  ROUTINE dom_vvl_sf_nxt  ***
-      !!                   
+      !!
       !! ** Purpose :  - compute the after scale factors used in tra_zdf, dynnxt,
       !!                 tranxt and dynspg routines
       !!
       !! ** Method  :  - z_star case:  Repartition of ssh INCREMENT proportionnaly to the level thickness.
-      !!               - z_tilde_case: after scale factor increment = 
+      !!               - z_tilde_case: after scale factor increment =
       !!                                    high frequency part of horizontal divergence
       !!                                  + retsoring towards the background grid
@@ -306,5 +303,5 @@
       !!
       !! ** Action  :  - hdiv_lf    : restoring towards full baroclinic divergence in z_tilde case
-      !!               - tilde_e3t_a: after increment of vertical scale factor 
+      !!               - tilde_e3t_a: after increment of vertical scale factor
       !!                              in z_tilde case
       !!               - e3(t/u/v)_a
@@ -410,5 +407,5 @@
             un_td(ji,jj,jk) = rn_ahe3 * umask(ji,jj,jk) * e2_e1u(ji,jj)           &
                &            * ( tilde_e3t_b(ji,jj,jk) - tilde_e3t_b(ji+1,jj  ,jk) )
-            vn_td(ji,jj,jk) = rn_ahe3 * vmask(ji,jj,jk) * e1_e2v(ji,jj)           & 
+            vn_td(ji,jj,jk) = rn_ahe3 * vmask(ji,jj,jk) * e1_e2v(ji,jj)           &
                &            * ( tilde_e3t_b(ji,jj,jk) - tilde_e3t_b(ji  ,jj+1,jk) )
             zwu(ji,jj) = zwu(ji,jj) + un_td(ji,jj,jk)
@@ -455,5 +452,5 @@
                WRITE(numout, *) 'at i, j, k=', ijk_max
                WRITE(numout, *) 'MIN( tilde_e3t_a(:,:,:) / e3t_0(:,:,:) ) =', z_tmin
-               WRITE(numout, *) 'at i, j, k=', ijk_min            
+               WRITE(numout, *) 'at i, j, k=', ijk_min
                CALL ctl_stop( 'STOP', 'MAX( ABS( tilde_e3t_a(:,:,: ) ) / e3t_0(:,:,:) ) too high')
             ENDIF
@@ -571,6 +568,6 @@
       !!----------------------------------------------------------------------
       !!                ***  ROUTINE dom_vvl_sf_update  ***
-      !!                   
-      !! ** Purpose :  for z tilde case: compute time filter and swap of scale factors 
+      !!
+      !! ** Purpose :  for z tilde case: compute time filter and swap of scale factors
       !!               compute all depths and related variables for next time step
       !!               write outputs and restart file
@@ -582,8 +579,8 @@
       !! ** Action  :  - tilde_e3t_(b/n) ready for next time step
       !!               - Recompute:
-      !!                    e3(u/v)_b       
-      !!                    e3w(:,:,:,Kmm)           
-      !!                    e3(u/v)w_b      
-      !!                    e3(u/v)w_n      
+      !!                    e3(u/v)_b
+      !!                    e3w(:,:,:,Kmm)
+      !!                    e3(u/v)w_b
+      !!                    e3(u/v)w_n
       !!                    gdept(:,:,:,Kmm), gdepw(:,:,:,Kmm)  and gde3w
       !!                    h(u/v) and h(u/v)r
@@ -616,5 +613,5 @@
             tilde_e3t_b(:,:,:) = tilde_e3t_n(:,:,:)
          ELSE
-            tilde_e3t_b(:,:,:) = tilde_e3t_n(:,:,:) & 
+            tilde_e3t_b(:,:,:) = tilde_e3t_n(:,:,:) &
             &         + rn_atfp * ( tilde_e3t_b(:,:,:) - 2.0_wp * tilde_e3t_n(:,:,:) + tilde_e3t_a(:,:,:) )
          ENDIF
@@ -628,7 +625,7 @@
       ! - ML - e3u(:,:,:,Kbb) and e3v(:,:,:,Kbb) are already computed in dynnxt
       ! - JC - hu(:,:,:,Kbb), hv(:,:,:,:,Kbb), hur_b, hvr_b also
-      
+
       CALL dom_vvl_interpol( e3u(:,:,:,Kmm), e3f(:,:,:), 'F'  )
-      
+
       ! Vertical scale factor interpolations
       CALL dom_vvl_interpol( e3t(:,:,:,Kmm),  e3w(:,:,:,Kmm), 'W'  )
@@ -649,5 +646,5 @@
          gdepw(ji,jj,jk,Kmm) = gdepw(ji,jj,jk-1,Kmm) + e3t(ji,jj,jk-1,Kmm)
          gdept(ji,jj,jk,Kmm) =    zcoef  * ( gdepw(ji,jj,jk  ,Kmm) + 0.5 * e3w(ji,jj,jk,Kmm) )  &
-             &             + (1-zcoef) * ( gdept(ji,jj,jk-1,Kmm) +       e3w(ji,jj,jk,Kmm) ) 
+             &             + (1-zcoef) * ( gdept(ji,jj,jk-1,Kmm) +       e3w(ji,jj,jk,Kmm) )
          gde3w(ji,jj,jk) = gdept(ji,jj,jk,Kmm) - ssh(ji,jj,Kmm)
       END_3D
@@ -768,5 +765,5 @@
       !!---------------------------------------------------------------------
       !!                   ***  ROUTINE dom_vvl_rst  ***
-      !!                     
+      !!
       !! ** Purpose :   Read or write VVL file in restart file
       !!
@@ -800,10 +797,4 @@
          IF( ln_rstart ) THEN                   !==  Read the restart file  ==!
             !
-#if defined key_agrif
-            IF ( (.NOT.Agrif_root()).AND.(ln_init_chfrpar) ) THEN
-               ! skip reading restart if initialized from parent:
-               id3 = -1 ; id4 = -1 ; id5 = -1
-            ELSE
-#endif
             CALL rst_read_open                                          !*  open the restart file if necessary
             !                                         ! --------- !
@@ -815,20 +806,17 @@
             id5 = iom_varid( numror, 'hdiv_lf'    , ldstop = .FALSE. )
             !
-#if defined key_agrif
-            ENDIF
-#endif
             !                                                           !*  scale factors
             IF(lwp) WRITE(numout,*)    '          Kmm scale factor read in the restart file'
             CALL iom_get( numror, jpdom_auto, 'e3t_n', e3t(:,:,:,Kmm) )
-            WHERE ( tmask(:,:,:) == 0.0_wp ) 
+            WHERE ( tmask(:,:,:) == 0.0_wp )
                e3t(:,:,:,Kmm) = e3t_0(:,:,:)
             END WHERE
             IF( l_1st_euler ) THEN                       ! euler
                IF(lwp) WRITE(numout,*) '          Euler first time step : e3t(Kbb) = e3t(Kmm)'
-               e3t(:,:,:,Kmm) = e3t(:,:,:,Kbb)
+               e3t(:,:,:,Kbb) = e3t(:,:,:,Kmm)
             ELSE                                         ! leap frog
                IF(lwp) WRITE(numout,*) '          Kbb scale factor read in the restart file'
                CALL iom_get( numror, jpdom_auto, 'e3t_b', e3t(:,:,:,Kbb) )
-               WHERE ( tmask(:,:,:) == 0.0_wp ) 
+               WHERE ( tmask(:,:,:) == 0.0_wp )
                   e3t(:,:,:,Kbb) = e3t_0(:,:,:)
                END WHERE
@@ -854,7 +842,7 @@
                      CALL iom_get( numror, jpdom_auto, 'tilde_e3t_b', tilde_e3t_b(:,:,:) )
                   ENDIF
-               ELSE 
-                 tilde_e3t_b(:,:,:) = 0.0_wp
-                 tilde_e3t_n(:,:,:) = 0.0_wp
+               ELSE
+                  tilde_e3t_b(:,:,:) = 0.0_wp
+                  tilde_e3t_n(:,:,:) = 0.0_wp
                ENDIF
                !                                      ! ------------ !
@@ -864,5 +852,5 @@
                      CALL iom_get( numror, jpdom_auto, 'hdiv_lf', hdiv_lf(:,:,:) )
                   ELSE                ! array is missing
-                     hdiv_lf(:,:,:) = 0.0_wp 
+                     hdiv_lf(:,:,:) = 0.0_wp
                   ENDIF
                ENDIF
@@ -885,17 +873,4 @@
       ELSEIF( TRIM(cdrw) == 'WRITE' ) THEN       !  Create restart file  !
          !                                       !=======================!
-#if defined key_agrif
-         IF ( .NOT.Agrif_root().AND.(ln_init_chfrpar) ) THEN
-            ! Interpolate initial ssh from parent:
-            CALL Agrif_istate_ssh( Kbb, Kmm )
-            !
-            DO jk = 1, jpk
-               e3t(:,:,jk,Kmm) =  e3t_0(:,:,jk) * ( ht_0(:,:) + ssh(:,:,Kmm)  ) &
-                 &                              / ( ht_0(:,:) + 1._wp - ssmask(:,:) ) * tmask(:,:,jk)   &
-                 &              + e3t_0(:,:,jk) * ( 1._wp - tmask(:,:,jk) )
-            END DO
-            e3t(:,:,:,Kbb) = e3t(:,:,:,Kmm)
-         ENDIF
-#endif
          !
          IF(lwp) WRITE(numout,*) '---- dom_vvl_rst ----'
@@ -911,5 +886,5 @@
             CALL iom_rstput( kt, nitrst, numrow, 'tilde_e3t_n', tilde_e3t_n(:,:,:))
          END IF
-         !                                           ! -------------!    
+         !                                           ! -------------!
          IF( ln_vvl_ztilde ) THEN                    ! z_tilde case !
             !                                        ! ------------ !
@@ -925,5 +900,5 @@
       !!---------------------------------------------------------------------
       !!                  ***  ROUTINE dom_vvl_ctl  ***
-      !!                
+      !!
       !! ** Purpose :   Control the consistency between namelist options
       !!                for vertical coordinate
@@ -934,5 +909,5 @@
          &              ln_vvl_zstar_at_eqtor      , rn_ahe3     , rn_rst_e3t            , &
          &              rn_lf_cutoff               , rn_zdef_max , ln_vvl_dbg                ! not yet implemented: ln_vvl_kepe
-      !!---------------------------------------------------------------------- 
+      !!----------------------------------------------------------------------
       !
       READ  ( numnam_ref, nam_vvl, IOSTAT = ios, ERR = 901)
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DOM/domzgr_substitute.h90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DOM/domzgr_substitute.h90	(revision 14199)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DOM/domzgr_substitute.h90	(revision 14200)
@@ -28,7 +28,22 @@
 #   define  gdepw(i,j,k,t) (gdepw_0(i,j,k)*(1._wp+r3t(i,j,t)))
 #   define  gde3w(i,j,k)   (gdept_0(i,j,k)*(1._wp+r3t(i,j,Kmm))-ssh(i,j,Kmm))
+#elif defined key_linssh
+#   define  e3t(i,j,k,t)   e3t_0(i,j,k)
+#   define  e3u(i,j,k,t)   e3u_0(i,j,k)
+#   define  e3v(i,j,k,t)   e3v_0(i,j,k)
+#   define  e3f(i,j,k)     e3f_0(i,j,k)
+#   define  e3f_vor(i,j,k) e3f_0vor(i,j,k)
+#   define  e3w(i,j,k,t)   e3w_0(i,j,k)
+#   define  e3uw(i,j,k,t)  e3uw_0(i,j,k)
+#   define  e3vw(i,j,k,t)  e3vw_0(i,j,k)
+#   define  ht(i,j)        ht_0(i,j)
+#   define  hu(i,j,t)      hu_0(i,j)
+#   define  hv(i,j,t)      hv_0(i,j)
+#   define  r1_hu(i,j,t)   r1_hu_0(i,j)
+#   define  r1_hv(i,j,t)   r1_hv_0(i,j)
+#   define  gdept(i,j,k,t) gdept_0(i,j,k)
+#   define  gdepw(i,j,k,t) gdepw_0(i,j,k)
+#   define  gde3w(i,j,k)   (gdept_0(i,j,k)-ssh(i,j,Kmm))
 #endif
 !!----------------------------------------------------------------------
-!!#   define  e3t_f(i,j,k)   (e3t_0(i,j,k)*(1._wp+r3t_f(i,j)*tmask(i,j,k)))
-!!#   define  e3u_f(i,j,k)   (e3u_0(i,j,k)*(1._wp+r3u_f(i,j)*umask(i,j,k)))
-!!#   define  e3v_f(i,j,k)   (e3v_0(i,j,k)*(1._wp+r3v_f(i,j)*vmask(i,j,k)))
+
